<!-- 采集数据页面 -->
<script lang="ts" setup name="addNotice">
import { ElMessage, ElMessageBox } from 'element-plus'
import editList from './collectAdd.vue'
import { deleteCollectList, getCollectList } from '@/api/api/index'
import { getDictByCode } from '@/api/system/dict'
const searchQuery = reactive({
  offset: 1,
  limit: 20,
  collectionType: '', // 设备分类
  deviceType: '', // 设备类型
  deviceNo: '', // 设备编号
})
const loadingTable = ref(true)
const columns = ref([
  { text: '采集类型', value: 'collectionTypeName', align: 'center' },
  { text: '设备类型', value: 'deviceTypeName', align: 'center' },
  { text: '设备编号', value: 'deviceNo', align: 'center' },
  { text: '安装位置', value: 'installLocaltion', align: 'center' },
  { text: '上报时间', value: 'uploadTime', align: 'center' },
  { text: '上报频率', value: 'frequency', align: 'center' },
  { text: '当前状态', value: 'deviceStatName', align: 'center' },
]) // 表格
const total = ref<number>(0)
const list = ref<any[]>([])
// 搜索
const search = () => {
  loadingTable.value = true
  getCollectList(searchQuery).then((res) => {
    list.value = res.data.rows
    total.value = res.data.total
    loadingTable.value = false
  })
}
const editRef = ref()
// 编辑
const edit = (row: any) => {
  editRef.value.initDialog('update', { ...row, deviceStat: row.deviceStat.toFixed(0) })
}
// 删除
const del = (row: any) => {
  ElMessageBox.confirm(
    '确认删除选中的数据吗?',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      deleteCollectList(row.id).then((res) => {
        ElMessage({
          type: 'success',
          message: '删除成功',
        })
        search()
      })
    })
    .catch(() => {
    })
}
// 新增
const add = (row: any) => {
  editRef.value.initDialog('create', {})
}
const collectTypeList = ref([])
// 获取采集分类列表
const getCollectionType = () => {
  getDictByCode('collection_type').then((res) => {
    collectTypeList.value = res.data
  })
}
const deviceTypeList = ref([])
// 获取设备类型
const getDeviceType = () => {
  getDictByCode('device_type').then((res) => {
    deviceTypeList.value = res.data
  })
}
getDeviceType()
getCollectionType()
// 重置
const reset = () => {
  searchQuery.collectionType = ''
  searchQuery.offset = 1
  searchQuery.limit = 20
  searchQuery.deviceType = ''
  searchQuery.deviceNo = ''
  search()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  // getList()
}
// 表格被选中的行
const selectList = ref<any[]>([])
// 表格多选
const multiSelect = (row: any[]) => {
  selectList.value = row
}
onMounted(() => {
  search()
})
</script>

<template>
  <div>
    <edit-list ref="editRef" @refresh="search" />
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-select v-model="searchQuery.collectionType" placeholder="采集类型">
          <el-option v-for="item in collectTypeList" :key="item.id" :label="item.name" :value="item.value" />
        </el-select>
      </search-item>
      <search-item>
        <el-select v-model="searchQuery.deviceType" placeholder="设备类型">
          <el-option v-for="item in deviceTypeList" :key="item.id" :label="item.name" :value="item.value" />
        </el-select>
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.deviceNo" placeholder="设备编号" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <!-- <template #btns>
        <el-button type="primary" style="margin-bottom: 10px;">
          参数设置
        </el-button>
      </template> -->
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button icon="icon-add" title="新增" @click="add" />
      </template>
      <!-- 表格区域 -->
      <normal-table
        :data="list" :total="total" :columns="columns as any"
        :query="{ limit: searchQuery.limit, offset: searchQuery.offset }" :list-loading="loadingTable"
        :is-showmulti-select="true" :is-multi="true" @change="changePage" @multiSelect="multiSelect"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column label="操作" align="center" width="120">
            <template #default="{ row }">
              <el-button type="primary" link size="small" @click="edit(row)">
                修改
              </el-button>
              <el-button type="primary" link size="small" @click="del(row)">
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </div>
</template>

